/*
This file is auto-generated by OWL2Go (https://git.rwth-aachen.de/acs/public/ontology/owl/owl2go).

Copyright 2020 Institute for Automation of Complex Power Systems,
E.ON Energy Research Center, RWTH Aachen University

This project is licensed under either of
- Apache License, Version 2.0
- MIT License
at your option.

Apache License, Version 2.0:

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

MIT License:

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package ontology

import (
	"errors"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/rdf"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/owl"
	"strings"
)

// SarefTask The goal for which a device is designed (from a user perspective). For example, a washing machine is designed for the task of washing. We propose here a list of tasks that are relevant for the purpose of SAREF, but this list can be extended.
type SarefTask interface {
	owl.Thing
	sarefIsAccomplishedByMultipleSarefDevice
	IsSarefTask() bool // indicates base class
}

// sSarefTask The goal for which a device is designed (from a user perspective). For example, a washing machine is designed for the task of washing. We propose here a list of tasks that are relevant for the purpose of SAREF, but this list can be extended.
type sSarefTask struct {
	propCommon
	propSarefIsAccomplishedByBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice
}

// NewSarefTask creates a new SarefTask
func (mod *Model) NewSarefTask(iri string) (ret SarefTask, err error) {
	if mod.Exist(iri) {
		err = errors.New("Resource already exists")
		return
	}
	res := &sSarefTask{}
	pc := propCommon{iri: iri, typ: "SarefTask", model: mod}
	res.propCommon = pc
	mod.addSarefTask(res)
	res.makeMaps()
	ret = res
	return
}

// makeMaps creates initiliazes maps
func (res *sSarefTask) makeMaps() {
	res.sarefIsAccomplishedBy = make(map[string]SarefDevice)
	return
}

// addSarefTask adds SarefTask to model
func (mod *Model) addSarefTask(res SarefTask) {
	mod.mSarefTask[res.IRI()] = res
	mod.mThing[res.IRI()] = res
	return
}

// SarefTask returns all resources with given prefix
func (mod *Model) SarefTask(prefix string) (res []SarefTask) {
	for i := range mod.mSarefTask {
		if strings.HasPrefix(i, prefix) {
			res = append(res, mod.mSarefTask[i])
		}
	}
	return
}

// RemoveObject deletes all its references in this object
func (res *sSarefTask) RemoveObject(obj owl.Thing, prop string) {
	switch prop {
	case "https://w3id.org/saref#isAccomplishedBy":
		if v, ok := obj.(SarefDevice); ok {
			res.DelSarefIsAccomplishedBy(v)
		}
	default:
	}
	return
}

// isSarefTask indicates base class
func (res *sSarefTask) IsSarefTask() bool {
	return true
}

// SetSarefIsAccomplishedBy is setter of A relationship indentifying the task accomplished by a certain entity (e.g., a device)
func (res *sSarefTask) SetSarefIsAccomplishedBy(in []SarefDevice) (err error) {
	temp := res.sarefIsAccomplishedBy
	res.sarefIsAccomplishedBy = make(map[string]SarefDevice)
	for i := range temp {
		temp[i].DelSarefAccomplishes(res)
	}
	err = res.AddSarefIsAccomplishedBy(in...)
	return
}

// AddSarefIsAccomplishedBy adds A relationship indentifying the task accomplished by a certain entity (e.g., a device)
func (res *sSarefTask) AddSarefIsAccomplishedBy(in ...SarefDevice) (err error) {
	for i := range in {
		if _, ok := res.sarefIsAccomplishedBy[in[i].IRI()]; !ok {
			res.sarefIsAccomplishedBy[in[i].IRI()] = in[i]
			in[i].AddSarefAccomplishes(res)
		}
	}
	return
}

// DelSarefIsAccomplishedBy deletes A relationship indentifying the task accomplished by a certain entity (e.g., a device)
func (res *sSarefTask) DelSarefIsAccomplishedBy(in ...SarefDevice) (err error) {
	for i := range in {
		if _, ok := res.sarefIsAccomplishedBy[in[i].IRI()]; ok {
			delete(res.sarefIsAccomplishedBy, in[i].IRI())
			in[i].DelSarefAccomplishes(res)
		}
	}
	return
}

// InitFromNode initializes the resource from a graph node
func (res *sSarefTask) InitFromNode(node *rdf.Node) (err error) {
	for i := range node.Edge {
		res.propsInit(node.Edge[i])
	}
	return
}

// propsInit initializes the property from a graph node
func (res *sSarefTask) propsInit(pred *rdf.Edge) (err error) {
	switch pred.Pred.String() {
	case "https://w3id.org/saref#isAccomplishedBy":
		if obj, ok := res.model.mSarefDevice[pred.Object.Term.String()]; ok {
			res.AddSarefIsAccomplishedBy(obj)
		}
	default:
	}
	return
}

// ToGraph creates a new owl graph node and adds it to the graph
func (res *sSarefTask) ToGraph(g *rdf.Graph) {
	node := owl.AddObjectToGraph(g, "https://w3id.org/saref#Task", res)
	res.propsToGraph(node, g)
	return
}

// propsToGraph adds all properties to the graph
func (res *sSarefTask) propsToGraph(node *rdf.Node, g *rdf.Graph) {
	res.propSarefIsAccomplishedByBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice.toGraph(node, g)
	return
}

// String prints the object into a string
func (res *sSarefTask) String() (ret string) {
	ret = res.iri + " " + "SarefTask\n"
	ret += res.propsString()
	return
}

// propsString prints the object into a string
func (res *sSarefTask) propsString() (ret string) {
	ret = ""
	ret += res.propSarefIsAccomplishedByBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice.String()
	return
}


